:- include( 'processes' ).

processdef( clock, [send(tock), clock] ).
processdef( clock(1), [send(tock), 0] ).
processdef( clock(N), [send(tock), clock(N1)], N1 is N-1 ).

processdef( bclock, [tock:=true, bclock] + [tock:=false, [error] * 0] ).

processdef( lamp, [nolight] * [on=true, [light] * [on=false, lamp] ] ).

processdef( osc, [out:=true, out:=false, osc] ).

processdef( switch, [mode := true, swon] + [tick, switch] ).
processdef( swon, [mode:=false, switch] + [tick, swon] ).

net( swlamp, [l1:lamp, s1:switch], [s1^mode/l1^on], [] ).
net( olamp, [l1:lamp, o1:osc], [o1^out/l1^on], [] ).

